freeslot(
"MT_SOLSFX",
"S_SOLSFX"
)

states[S_SOLSFX] = {
    tics = 1000,
    nextstate = S_NULL,
}

mobjinfo[MT_SOLSFX] = {
    flags = MF_NOGRAVITY,
    doomednum = -1,
    spawnstate = S_SOLSFX,
    deathstate = S_NULL,
}

addHook("MobjDeath", function (mo)
--addHook("MobjThinker", function (mo)
        if not (mo and mo.valid and mo.player) then return false end
        
        if mo.skin == "sol"
            local cmd = mo.player.cmd
            
            /*if (cmd.buttons & BT_LUAA) == 0 then
                return
            end*/
            
            --S_StartSoundAtVolume(mo, sfx_s24c, 255, nil)
            --print("sfx spawned!")
            local sfx = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SOLSFX)
            sfx.health = 0
            sfx.reactiontime = 0
            sfx.state = S_SOLSFX
            sfx.target = mo
        end
        return false
end)

addHook("MobjThinker", function(mo)
        if not mo.target then return false end
        if mo.reactiontime  == 0 then
            mo.health = mo.target.hitlag
            if mo.health == 0 then
                --print("first hitlag done")
                mo.reactiontime  = 1
                return false
            end
        end
        if mo.reactiontime == 1 then
            mo.health = mo.target.hitlag
            if mo.health == 0 then
                --print("second hitlag done")
                mo.reactiontime = 2
                return false
            end
        end
        if mo.reactiontime == 2 then
            mo.health = mo.target.hitlag
            if mo.health == 1 then
                --print("third hitlag done")
                mo.reactiontime = 3
                S_StartSoundAtVolume(mo, sfx_s24c, 255, nil)
                return false
            end
        end
        
        return false
end, MT_SOLSFX)